# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
    def self.get_file(dir_s4u_name,s4u_name,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        if File.exist?(file_name_full)
            file= File.new(file_name_full,"r")
            str=file.readlines
            file.close
            return str.collect{|s| s.chomp}
        end
        return false
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
    def self.set_file(dir_s4u_name,s4u_name,list,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        file= File.new(file_name_full, mode: 'w:UTF-8')
        str=list.join("\n")
        file.syswrite str
        file.close
        return true
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
	module S4u_crop_selection
		class Select
			def initialize(selection_mode=0)
                @selection_mode=selection_mode
				ext=IS_OSX ? ".pdf" : ".svg"
				#cursor_path= File.join(Dir_s4u_name,("icon_mouse" + ext))
				#@cursor_id = UI.create_cursor(cursor_path,0,0) if cursor_path
                @cursors=[]
                list=["polyline","circle","rectangle","lasso"]
                list.each{|e|
                    path= File.join(Dir_s4u_name,NAME + "_" + e + ext)
                    @cursors<<UI.create_cursor(path,0,0) if File.exist? path
                }
				@selection_mode_list=[Strings["Polyline"],Strings["Circle"],Strings["Rectangle"]]
				@crossing_mode_list=[Strings["Window"],Strings["Crossing"]]
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@snap=20*@scale_factor
			end
			def activate
				@selection=[]
				model=Sketchup.active_model
				@edit_transform=Sketchup.active_model.axes.transformation
				@ip=Sketchup::InputPoint.new
				@ips=[]
				self.get_setting
				self.reset
			end
			def onSetCursor
				#UI.set_cursor(@cursor_id) if @cursor_id
                if @selection_mode==0 && @lasso
                    UI.set_cursor(@cursors[3])
                elsif @selection_mode==1 || @alt_press
                    UI.set_cursor(@cursors[1])
                else
                    UI.set_cursor(@cursors[@selection_mode])
                end
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				@ips.each{|p| bb.add(p.position) if p && p.valid?}
				return bb
			end
			def get_setting
				@selection_mode=0
				@last_parameter=nil
				@setting = S4U::S4u_crop_selection::instance_variable_get :@setting
				if @setting && @setting.length==2
					@selection_mode=@setting[0]
					@last_parameter=@setting[1]
				end
			end
			def deactivate(view)
				@setting=[]
				@setting[0]=@selection_mode
				@setting[1]=@last_parameter
				S4U::S4u_crop_selection::instance_variable_set(:@setting,@setting)
			end
			def setstatus(view=nil)
				text= IS_OSX ? Strings["Shift to Extend Select. Drag Mouse to Lasso. Click Mouse to Polyline. Hold CONTROL to Circle. Press TAB to Reverse Side Selection"] :
							Strings["Shift to Extend Select. Drag Mouse to Lasso. Click Mouse to Polyline. Hold ALT to Circle. Press TAB to Reverse Side Selection"]
				text+= " | "
				if @state==0
					text+=Strings["Select First Point"]
				elsif @state>=1
					text+= Strings["Double Click or First Point to Finish"]
				end
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
					view.line_width=2
					if @ip && @ip.valid?
						if @onpoint
							view.draw_points @ip.position, 10*@scale_factor, 1, "red"
						# elsif @edge
							# view.draw_points @ip.position, 5*@scale_factor, 1, "red"
						# elsif @ip.display?
							# @ip.draw(view)
						end
					end
					if @state>=1 && @ips.length>0
						if @ip.valid?
							if @state>=1 && (@alt_press || @selection_mode==1 || @selection_mode==2)
								view.drawing_color="blue"
								view.line_stipple = @crossing_mode==0 ? "" : "-"
								view.line_width=2
								if @alt_press || @selection_mode==1
									p1=view.screen_coords(@ips[-1].position)
									p3=view.screen_coords(@ip.position)
									ps=draw_circle(view.screen_coords(@ips[-1].position),Z_AXIS,(view.screen_coords(@ip.position).distance view.screen_coords(@ips[-1].position)))
									view.draw2d GL_LINE_LOOP,ps
									view.line_stipple=""
									view.drawing_color="orange"
									view.line_width=5
									d=5*@scale_factor
									d=-d if @rever_plane==1
									ps1=draw_circle(view.screen_coords(@ips[-1].position),Z_AXIS,(view.screen_coords(@ip.position).distance view.screen_coords(@ips[-1].position))+d)
									view.draw2d GL_LINE_LOOP,ps1
									@points=ps.clone
								else
									p1=view.screen_coords(@ips[-1].position)
									p3=view.screen_coords(@ip.position)
									p2=Geom::Point3d.new(p1.x,p3.y,0)
									p4=Geom::Point3d.new(p3.x,p1.y,0)
									view.draw2d GL_LINE_LOOP,[p1,p2,p3,p4]
									view.line_stipple =""
									p1.z=0;p3.z=0
									ps = [p1,p2,p3,p4,p1]
									@points=ps
                                    ps_orange=[]
									(0..ps.length-2).each{|i|
										pp1=ps[i]
										pp2=ps[i+1]
										p2_p1=pp2-pp1
										p2_p1.z=0
										v=Z_AXIS.cross p2_p1
										if v and v.length>0
											v.reverse! if @rever_plane==1
											v.length=5*@scale_factor
											p11=pp1.clone + v
											p21=pp2.clone + v
                                            ps_orange<< [p11,p21]
										end
									}
                                    view.line_width=5
                                    view.drawing_color="orange"
                                    ps_orange<<ps_orange[0]
                                    view.draw2d GL_LINE_STRIP,ps_orange.flatten if ps_orange.flatten.length>1
								end
							elsif @selection_mode==0
								view.drawing_color="blue"
								view.line_stipple = @crossing_mode==0 ? "" : "-"
								view.line_width=2
								view.draw2d GL_LINES,[view.screen_coords(@ip.position),view.screen_coords(@ips[-1].position)]
								(0..@ips.length-2).each{|i|
									view.draw2d GL_LINES,[view.screen_coords(@ips[i].position),view.screen_coords(@ips[i+1].position)]
								}
                                if @lasso
                                    view.draw2d GL_LINES,[view.screen_coords(@ip.position),view.screen_coords(@ips[0].position)]
                                end
								view.line_stipple =""
                                ps_orange=[]
								(0..@ips.length-2).each{|i|
									p1=view.screen_coords(@ips[i].position)
									p2=view.screen_coords(@ips[i+1].position)
									p2_p1=p2-p1
									p2_p1[2]=0
									v=Z_AXIS.cross p2_p1
									if v and v.length>0
										v.reverse! if @rever_plane==1
										v.length=5*@scale_factor
										p11=p1.clone + v
										p21=p2.clone + v
                                        ps_orange+=[p11,p21]
									end
								}
								p1=view.screen_coords(@ips[-1].position)
								p2=view.screen_coords(@ip.position)
								p2_p1=p2-p1
								p2_p1[2]=0
								v=Z_AXIS.cross p2_p1
								if v && v.length>0
                                    if @lasso
									    v.reverse! if @rever_plane==0
                                    else
                                        v.reverse! if @rever_plane==1
                                    end
									v.length=5*@scale_factor
									p11=p1.clone + v
									p21=p2.clone + v
                                    ps_orange+=[p11,p21]
								end
                                if @lasso
                                    p1=view.screen_coords(@ips[-1].position)
                                    p2=view.screen_coords(@ips[0].position)
                                    p2_p1=p2-p1
                                    p2_p1[2]=0
                                    v=Z_AXIS.cross p2_p1
                                    if v && v.length>0
                                        v.reverse! if @rever_plane==1
                                        v.length=5*@scale_factor
                                        p11=p1.clone + v
                                        p21=p2.clone + v
                                        ps_orange+=[p11,p21]
                                        ps_orange<<ps_orange[0]
                                    end
                                end
                                view.line_width=5
                                view.drawing_color="orange"
                                view.draw2d(GL_LINE_STRIP,ps_orange.flatten) if ps_orange.length>1
							end
                            if @ctrl_press
                                view.line_width=1
                                color = Sketchup::Color.new "DodgerBlue"
                                color.alpha = 70
                                view.drawing_color=color
                                ps = @ips.collect{|p| p.position}
                                ps<<@ip.position if @ip.valid?
                                size=view.pixels_to_model(5*@scale_factor, @ip.position)
                                ps<<ps[0] if @lasso
                                ps1 = ps.collect{|p| Geom::Point3d.new(p.x,p.y,-size)}
                                ps2 = ps.collect{|p| Geom::Point3d.new(p.x,p.y,size)}
                                (0..ps.length-2).each{|i|
                                    view.draw GL_QUADS,[ps1[i],ps1[i+1],ps2[i+1],ps2[i]]
                                }
                            end
						end
					end
				self.setstatus
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(100*@scale_factor, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper
				ph.init(x, y)
				picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,@snap) }
				if picked
					ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
					p=view.screen_coords(picked.transform ip.transformation)
					ip.pick view,p.x,p.y,ip1
					view.tooltip=Strings["1/3"]
				end
				return nil
			end
			def set_onpoint(x,y,view,ip,point)
				return nil if !ip || !point
				ph = view.pick_helper
				ph.init(x, y)
				picked = ph.test_point((point.position),x,y,@snap)
				if picked
					ip1=Sketchup::InputPoint.new(point.position)
					p=view.screen_coords(point.position)
					ip.pick view,p.x,p.y,ip1
					view.tooltip=Strings["Close"]
					return true
				end
				return nil
			end
			def onMoveConstructionLine(view,element)
				return nil if !element.is_a?(Sketchup::ConstructionLine)
				p=ORIGIN
				p1=p+element.direction
				line=p1-p
				line.reverse! if view.screen_coords(p1).x< view.screen_coords(p).x
				if @edit_transform.zaxis.parallel? line
					normal=@edit_transform.zaxis
				else
					normal=line.cross @edit_transform.zaxis
				end
				return normal
			end
			def onMouseMove(flags, x, y, view)
				#@x=@y=0 if !@x
               # return if  @x && ((x-@x).abs<3*@scale_factor) && ((y-@y).abs<3*@scale_factor)
              #  @x,@y=x,y
				@shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
				@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
				@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)
				@flags=((flags&1)==1)
				#@edge=nil
				#@trans=nil
				#ph = view.pick_helper
				#ph.do_pick(x, y)
                if @state==0
                    @ip.pick view,x,y
                    view.tooltip = @ip.tooltip
                    # @edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
                    #@rever_plane=0 if !@rever_plane
                    @face=@ip.face
                    #@trans=@ip.transformation
                    view.invalidate if @ip.valid?
                elsif  @state>=1
                    # best_pick = ph.all_picked
                    # @elements+= best_pick if best_pick
                    @ip.pick view,x,y,@ips[@state-1]
                    view.tooltip = @ip.tooltip
					@xy[1]=[x,y] if @xy && @xy.length<=2
                    if @state==1 && @ips.length<3
                        if @xy && @xy.length>1
                            if @xy[1].x>=@xy[0].x
                                @crossing_mode = 0
                                if @xy[1].y>@xy[0].y
                                    if @selection_mode==0 && !@alt_press
                                        @rever_plane=1
                                    elsif @selection_mode==1 || @alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==2
                                        @rever_plane=0
                                    end
                                else
                                    if @selection_mode==0 && !@alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==1 || @alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==2
                                        @rever_plane=1
                                    end
                                end
                            else
                                @crossing_mode = 1
                                if @xy[1].y>@xy[0].y
                                    if @selection_mode==0 && !@alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==1 || @alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==2
                                        @rever_plane=1
                                    end
                                else
                                    if @selection_mode==0 && !@alt_press
                                        @rever_plane=1
                                    elsif @selection_mode==1 || @alt_press
                                        @rever_plane=0
                                    elsif @selection_mode==2
                                        @rever_plane=0
                                    end
                                end
                            end
                        end
                    end
                    if @ip.valid? && @selection_mode==0 && !@alt_press && @flags && @ips.length>0 &&
                        @ip.position.distance(@ips[-1].position)>5
                        @lasso=true
                        @ips<<Sketchup::InputPoint.new
                        if @onpoint
                            @ips[-1].copy! @ips[0]
                            @ip.copy! @ips[0]
                        else
                            @ips[-1].copy! @ip
                        end
                        @ips[-1].copy! @ip
                        add_ip(view.screen_coords(@ips[-1].position),view)
                        if @ips.length>1
                            plane=add_plane
                            @planes<<plane if plane
                        end
                        #view.lock_inference if view.inference_locked?
                    end
					@onpoint=set_onpoint(x,y,view,@ip,@ips[0])
                    #@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
                    view.invalidate if @ip.valid?
                end
			end
			def onLButtonDown(flags, x, y, view)
				model=view.model
				if @state==0
					if @ip.valid?
						# if @alt_press
							# p1=@ip.position
							# vz=@plane_transform.zaxis
							# plane=[[p1,vz],nil,nil,[p1,vz.reverse]]
							# @planes<<plane
							# process_select(plane)
							# self.reset(view)
						# else
							@ips<< Sketchup::InputPoint.new
							@ips[-1].copy! @ip
							add_ip(view.screen_coords(@ips[-1].position),view)
							@state+=1
							@xy=[[x,y]]
							# @elements.clear
						# end
					end
				elsif @state>=1 && @ip.valid?
					if @selection_mode==0 && !@alt_press && !@lasso
						@ips<<Sketchup::InputPoint.new
						if @onpoint
							@ips[-1].copy! @ips[0]
							@ip.copy! @ips[0]
						else
							@ips[-1].copy! @ip
						end
						# if @p_shift && @ip!=@ips[@state-1]
							# p2_line=@ip.position.project_to_line([@ips[-2].position,@p_shift])
							# @ips[-1].copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
						# else
							@ips[-1].copy! @ip
						# end
						add_ip(view.screen_coords(@ips[-1].position),view)
						if @ips.length>1
							plane=add_plane
							@planes<<plane if plane
						end
						if @onpoint
							process_select()
							self.reset(view)
						else
							@state+=1
						end
					else
						@state+=1
					end
				end
				self.setstatus(view)
				rescue=>error
					p error
					p error.backtrace.join('\n')
					self.reset(view)
			end
			def add_points(ps,view)
				ps.each{|p|
					@ips<< Sketchup::InputPoint.new
					@ips[-1].copy! @ip
					add_ip(p,view)
					if @ips.length>1
						plane=add_plane
						@planes<<plane if plane
					end
				}
			end
			def onLButtonUp(flags, x, y, view)
				if @state>=1
					if (@alt_press || @selection_mode==1 || @selection_mode==2) && ((@state>=1 && @flags) || (!@flags && @state>=2))
						if @points && @points.length>2 &&
							@xy.length>1 && (@xy[0].x-@xy[1].x).abs>5 && (@xy[0].y-@xy[1].y).abs>5
							add_points(@points,view)
							@onpoint=true
							process_select(@points)
							self.reset(view)
						end
					elsif @lasso && @selection_mode==0 && @ips.length>5 && !@alt_press &&
                        @xy.length>1 && (@xy[0].x-@xy[1].x).abs>5 && (@xy[0].y-@xy[1].y).abs>5
						@ips[-1].copy! @ips[0]
						process_select()
						self.reset(view)
					end
				end

			end
			def add_ip(p_screen,view=Sketchup.active_model.active_view)
				ray=view.pickray p_screen.x, p_screen.y
				@ips[-1].pick(view,p_screen.x, p_screen.y)
				@rays[@ips[-1]]=ray
			end
			def add_plane(ip1=@ips[-2],ip2=@ips[-1])
				p1=ip1.position
				p2=ip2.position
				vx= p1.vector_to p2
				vz=Z_AXIS
				vy=vz.cross vx
				plane=nil
				if  @ctrl_press && vy.length>0
					if vy.length>0
						plane=[[p1,vy],[p1,vx],[p2,vx.reverse],[p1,vy.reverse]]
						return plane
					end
				else
					ray1=@rays[ip1]
					ray=@rays[ip2]
					if ray && ray1
						vec= p1.vector_to p2
						normal=vec.cross ray[1]
						normal1=ray[1].cross vec
						if normal.length>0 && normal1.length>0
							v1=ray1[1].cross normal
							v=normal.cross ray[1]
							if v.length>0 and v1.length>0
								plane=[[p1,normal],[p1,v1],[p2,v],[p1,normal1]]
								return plane
							end
						end
					end
				end
				return plane
			end
			def onLButtonDoubleClick(flags, x, y, view)
				if (@state>=1) && @ip.valid? && @selection_mode==0
					process_select()
					self.reset(view)
				end
			end
			def check_direction_points(ps_screen,rever_plane=0)
				i= (ps_screen.length>2)? 1 : 0
				p = self.middle_point([ps_screen[i],ps_screen[i+1]])
				v=ps_screen[i+1]-ps_screen[i]
				v1=v.cross Z_AXIS
				v1.length=5
				v1.reverse! if rever_plane==1
				p =p + v1
				return Geom.point_in_polygon_2D( p,ps_screen,false)
			end
			def process_select(points=nil)
				model=Sketchup.active_model
				entities=model.active_entities
				view=Sketchup.active_model.active_view
				# model.start_operation TOOL,true,false,false
					sel=model.selection.to_a
					sel=model.active_entities.to_a if sel.empty? || @shift_press
					if sel.length>0
						planes_ins=[]
						(0..@planes.length-1).each{|i|
							if @rever_plane==1
								t=@planes[i][0][1]
								@planes[i][0][1]=@planes[i][3][1]
								@planes[i][3][1]=t.clone
							end
						}
						if @planes.length>1
							ps_screen,planes= get_polygon(sel,view)
							(0..planes.length-1).each{|i|
								if @rever_plane==1
									t=planes[i][0][1]
									planes[i][0][1]=planes[i][3][1]
									planes[i][3][1]=t
								end
							}
							in_ps_screen=check_direction_points(ps_screen,@rever_plane)
							in_ps_screen= !in_ps_screen if @ctrl_press
							ps_screen=points if points
							planes_ins=[@planes,ps_screen,true,in_ps_screen,@ctrl_press,planes]
						else
							planes_ins=[@planes,[],false,true,@ctrl_press,@planes]
						end
						planes_ins[0]=planes_ins[5].clone

						selection = self.select_element(sel,planes_ins,@crossing_mode,Geom::Transformation.new)
						@last_parameter=planes_ins.clone
						model.selection.clear if !@shift_press
						if selection.length>0
							model.selection.add selection
							@selection=model.selection.to_a
						end
					end
				# model.commit_operation
				rescue=>error
					# model.abort_operation
					p error
					p error.backtrace.join('\n')
			end
			def last_parameter()
				if @last_parameter
					model=Sketchup.active_model
					entities=model.active_entities
					view=Sketchup.active_model.active_view
					sel=model.selection.to_a
					sel=model.active_entities.to_a if sel.empty? || @shift_press
					selection = self.select_element(sel,@last_parameter,@crossing_mode,Geom::Transformation.new)
					model.selection.clear if !@shift_press
					if selection.length>0
						model.selection.add selection
						@selection=model.selection.to_a
					end
				end
			end
			def screen_coords(point,ctrl_press=@ctrl_press,view=Sketchup.active_model.active_view)
				p=ctrl_press ? Geom::Point3d.new(point.x,point.y,0) : view.screen_coords(point)
				p.z=0
				return p
			end
			def get_triangle(sels,ips=@ips,view=Sketchup.active_model.active_view)
				bound= Geom::BoundingBox.new
				sels.each{|e| bound.add(e.bounds) if defined?(e.bounds)}
				ips.each{|p| bound.add(p.position)}
				corner_screen=(0..7).collect{|i| screen_coords(bound.corner(i))}
				min_max_x=corner_screen.minmax_by{|c| c.x}
				min_max_y=corner_screen.minmax_by{|c| c.y}
				dx=min_max_x[1].x-min_max_x[0].x
				dy=min_max_y[1].y-min_max_y[0].y
				min=Geom::Point3d.new(min_max_x[0].x,min_max_y[0].x,0)
				number=10
				p1=min.clone
				p1.x=p1.x-number*dx ; p1.y=p1.y-number*dy
				p2=min.clone
				p2.x=p2.x+number*dx
				p3=min.clone
				p3.y=p3.y+number*dy

				return [p1,p2,p3]
			end
			def get_vector_screen(vector)
				view=Sketchup.active_model.active_view
				origin=screen_coords(ORIGIN)
				p_origin=ORIGIN+vector
				p=screen_coords(p_origin)
				origin.z=0;p.z=0
				return (p-origin)
			end
			def get_polygon(sels,view=Sketchup.active_model.active_view)
				ps= @ips.collect{|p| screen_coords(p.position)}
				ps_screen=ps.collect{|p| Geom::Point3d.new(p.x,p.y,0)}
				ps_end=[]
				if !@onpoint
					line_end=[ps_screen[-2],ps_screen[-1]]
					line_start=[ps_screen[1],ps_screen[0]]
					p=Geom::intersect_line_line(line_end,line_start)
					if p && (!((Geom.point_in_polygon_2D(line_end[0],[line_end[1],p],true)) ||
						(Geom.point_in_polygon_2D(line_start[0],[line_start[1],p],true))))
						if Geom.point_in_polygon_2D(p,line_end,true) || Geom.point_in_polygon_2D(line_end[1],[line_end[0],p],true)
							ps_screen[-1]=p
						end
						if Geom.point_in_polygon_2D(p,line_start,true) || Geom.point_in_polygon_2D(line_start[1],[line_start[0],p],true)
							ps_screen[0]=p
						end
						ps_end<<p
					else
						triangle=get_triangle(sels,@ips,view)
						ps=triangle*2
						plane_end=nil
						plane_start=nil
						(0..2).each{|i|
							line=[ps[i],ps[i+1]]
							p = Geom::intersect_line_line(line,line_end)
							if p && (Geom.point_in_polygon_2D(p,[line[0],line[1]],true)) &&
								self.point_on_plane(p,[line_end[1],(line_end[1]-line_end[0])])>=0
								if self.point_on_plane(line[0],[p,get_vector_screen(@planes[-1][0][1])])>=0
									plane_end=[p,i]
								else
									plane_end=[p,i+1]
								end
							end
							p1 = Geom::intersect_line_line(line,line_start)
							if p1 && (Geom.point_in_polygon_2D(p1,[line[0],line[1]],true)) &&
								self.point_on_plane(p1,[line_start[1],(line_start[1]-line_start[0])])>=0
								if self.point_on_plane(line[0],[p1,get_vector_screen(@planes[0][0][1])])>=0
									plane_start=[p1,i]
								else
									plane_start=[p1,i+1]
								end
							end
							if p && p1 &&
								self.point_on_plane(p,[line_end[1],(line_end[1]-line_end[0])])>=0 &&
								self.point_on_plane(p1,[line_start[1],(line_start[1]-line_start[0])])>=0 &&
								(Geom.point_in_polygon_2D(p,[line[0],line[1]],true)) &&
								(Geom.point_in_polygon_2D(p1,[line[0],line[1]],true))
								ps_end<<p
								ps_end<<p1
							end
						}
						if ps_end.empty? && plane_start && plane_end
							ps_end<<plane_end[0]
							ps_end<<ps[plane_end[1]]
							plane_start[1]=(plane_start[1])%3
							plane_end[1]=(plane_end[1])%3
							step=plane_end[1]-plane_start[1]
							(0..step.abs).step(1).each{|i|
								s=step+i
								ps_end<< ps[s] if !ps_end.include?(ps[s])
							}
							ps_end<< ps[plane_start[1]] if plane_start[1] && !ps_end.include?(ps[plane_start[1]])
							ps_end<< plane_start[0] if plane_start[0] && !ps_end.include?(plane_start[0])
						end

					end
				end
				planes=[]
				ps1=[]
				(ps_screen+ps_end).each{|pi| (ps1<< pi) if !ps1.include?(pi)}
				ps1<<ps1[0] if ps1[-1]!=ps1[0]
				pend=ps1.clone
				@ips.clear
				@rays.clear
				(0..ps1.length-2).each{|i|
					if @ctrl_press
						@ips<<Sketchup::InputPoint.new(ps1[i])
						@ips<<Sketchup::InputPoint.new(ps1[i+1])
					else
						@ips<<Sketchup::InputPoint.new
						add_ip([ps1[i].x, ps1[i].y],view)
						@ips<<Sketchup::InputPoint.new
						add_ip([ps1[i+1].x, ps1[i+1].y],view)
					end
					plane=add_plane
					if plane
						planes<<plane
					end
				}
				(0..pend.length-1).each{|i| pend[i].z=0}
				return [pend,planes]
			end
			def draw_circle(point=ORIGIN,vector=Z_AXIS,radius=1,numsegs=48)
				c=[]
				a=2*Math::PI / numsegs
				(0..numsegs).each{|t| c<< ([radius*Math::cos(t*a),radius*Math::sin(t*a),0].transform! Geom::Transformation.new( point,vector)) }
				c.each_index{|i| c[i].z=0}
				return c.reverse
			end
			def getMenu(menu)
				menus=[]
				@selection_mode_list.each_index{|i| menus<< menu.add_item(@selection_mode_list[i]) {@selection_mode=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}

				menu.set_validation_proc(menus[@selection_mode]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@crossing_mode_list.each_index{|i| menus<< menu.add_item(@crossing_mode_list[i]) {@crossing_mode=i }}
				menus.each{|m| menu.set_validation_proc(m) {  @state>0 ? MF_UNCHECKED : MF_GRAYED  }}
				menu.set_validation_proc(menus[@crossing_mode]) { @state>0 ? MF_CHECKED : MF_GRAYED }
				menu.add_separator
				menus=[]
				menus<< menu.add_item(Strings["Reverve Side"]){ @rever_plane=1-@rever_plane}
				menu.set_validation_proc(menus[-1]) {  @state>=1 ? MF_UNCHECKED : MF_GRAYED }
				menus<< menu.add_item(Strings["Last Zone Selection"]){ last_parameter() }
				menu.set_validation_proc(menus[-1]) {  @last_parameter ? MF_UNCHECKED : MF_GRAYED }
				menus<< menu.add_item(Strings["Invert Selection"]){
					sel=Sketchup.active_model.selection.to_a
					Sketchup.active_model.selection.clear
					Sketchup.active_model.selection.add (Sketchup.active_model.active_entities.to_a-sel)
				}
				menu.set_validation_proc(menus[-1]) { MF_UNCHECKED}
                menu.add_separator
                menus<< menu.add_item(Strings["Setting"]){
					S4U::S4u_crop_selection.save_setting
				}
				menu.set_validation_proc(menus[-1]) { MF_UNCHECKED}
				return true
			end
			def onKeyDown(key, repeat, flags, view)
				if key==CONSTRAIN_MODIFIER_KEY
					@shift_press=true
				elsif key==VK_UP
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0  && @ips[-1] && @ips[-1].position
						p= @ips[-1].position
						p1=p + @edit_transform.zaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				elsif key==VK_LEFT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0 && @ips[-1] && @ips[-1].position
						p=  @ips[-1].position
						p1=p + @edit_transform.yaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				elsif key==VK_RIGHT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0 && @ips[-1] && @ips[-1].position
						p= @ips[-1].position
						p1=p + @edit_transform.xaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_press=true
				elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
					@alt_press=true
				end
			end
			def onKeyUp(key, repeat, flags, view)
				if (key==CONSTRAIN_MODIFIER_KEY)
					view.lock_inference if view.inference_locked?
					@shift_press=nil
				elsif (key==9) || ((key==48) && IS_OSX)
					@rever_plane=1-@rever_plane
					self.setstatus(view)
				elsif key==VK_DOWN
					@crossing_mode=1-@crossing_mode
					self.setstatus(view)
				elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_press=nil
				elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
					@alt_press=nil
				end
			end
			def onCancel(reason, view)
				self.reset(view)
			end
			def onReturn(view)
				if (@state>=1) && @ip.valid? && @ips.length>1 && @selection_mode==0
					process_select()
					self.reset(view)
				end
			end
			def reset(view=nil)
				view.lock_inference if view
				@rays={}
				#@elements=[]
				@state=0
				@ips=[]
				@ip.clear
				@sectionplanes=[]
				@onpoint=false
				@planes=[]
				@selection.clear
				@points=[]
				@xy=nil
				@rever_plane=0
				@x=@y=0
                @lasso=false
				@crossing_mode=0
				self.setstatus(view)
			end
			def resume(view)
				self.setstatus(view)
			end
			def select_element(sel,planes_ins,crossing_mode,t)
				selection=[]
				edges=[]
				planes_in=planes_ins[0]
				check_hide_edge=!Sketchup.active_model.rendering_options['DrawHidden']
				# planes=planes_in.transpose
				sel.each{|e|
					if e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Image) ||
						e.is_a?(Sketchup::Text) || e.is_a?(Sketchup::Dimension) || e.is_a?(Sketchup::ConstructionPoint) ||
						e.is_a?(Sketchup::SectionPlane)
						on_plane=element_on_planes(e,planes_ins,t)
						if on_plane==1
							selection<<e
						elsif on_plane==0 && crossing_mode==1
							selection<<e
						end
					elsif e.is_a?(Sketchup::ConstructionLine) && crossing_mode==1
						ps=e.position
						v=e.direction.clone
						v.length=100
						pe=ps+v
						ps=screen_coords(ps)
						pe=screen_coords(pe)
						ps.z=pe.z=0
						line=[ps,pe-ps]
						(0..planes_ins[1].length-2).each{|i|
							line1=[planes_ins[1][i],planes_ins[1][i+1]-planes_ins[1][i]]
							if line1[1].length!=0
								p= Geom::intersect_line_line(line,line1)
								if  p
									if planes_ins[3] && Geom::point_in_polygon_2D(p, [planes_ins[1][i+1],planes_ins[1][i]],true)
										selection<< e
										break
									elsif !planes_ins[3] && !Geom::point_in_polygon_2D(p, [planes_ins[1][i+1],planes_ins[1][i]],true)
										selection<< e
										break
									end
								end
							end
						}
					elsif (e.is_a?Sketchup::Edge) && !edges.include?(e)
						ps=e.start.position.transform t
						pe=e.end.position.transform t
						if crossing_mode==1
							if  points_on_planes([ps,ps],planes_ins) || points_on_planes([pe,pe],planes_ins)
								if e.curve && crossing_mode==1
									edges+=e.curve.edges
								else
									edges<< e
								end
							elsif planes_ins[1].length>0
								ps_screen=screen_coords(ps)
								pe_screen=screen_coords(pe)
								line1=[ps_screen,pe_screen-ps_screen]
								(0..planes_ins[1].length-2).each{|i|
									line2=[planes_ins[1][i],planes_ins[1][i+1]-planes_ins[1][i]]
									if line1[1].length!=0 && line2[1].length!=0
										p= Geom::intersect_line_line(line1,line2)
										if p && Geom::point_in_polygon_2D(p,[ps_screen,pe_screen],true) && Geom::point_in_polygon_2D(p,[planes_ins[1][i+1],planes_ins[1][i]],true)
											if e.curve && crossing_mode==1
												edges+=e.curve.edges
											else
												edges<< e
											end
											break
										end
									end
								}
							end
						else
							if  points_on_planes([ps,ps],planes_ins) && points_on_planes([pe,pe],planes_ins)
								if e.curve && crossing_mode==1
									edges+=e.curve.edges
								else
									edges<< e
								end
							end
						end
					elsif e.is_a?Sketchup::Face
						psv=e.vertices.collect{|pv| pv.position.transform t}
						center1=nil
						center=center_face(e)
						cp=e.classify_point(center_face(e))
						center1=center.transform(t) if cp && cp==Sketchup::Face::PointInside
						point_about=psv.all?{|p| points_on_planes([p,p],planes_ins)}
						if point_about
							selection<<e
						elsif center1 && points_on_planes([center1,center1],planes_ins)
							selection<<e if crossing_mode==1
						elsif crossing_mode==1
							psv_screen=psv.collect{|p| screen_coords(p)}
							if planes_ins[1].length>0 && planes_ins[1].all?{|p| Geom::point_in_polygon_2D(p,psv_screen,true)}
								selection<<e
							end
						end
					end
				}
				selection+=edges
				if crossing_mode==1
					selection+= edges.flat_map{|e| e.faces}.uniq
				else
					sel.each{|e|
						if e && e.valid? && (e.is_a?Sketchup::Face) && (edges & e.edges).length>=e.edges.length
							selection<<e
						end
					}
				end
				selection.uniq!
				sels=[]
				selection.each_index{|i| sels<<selection[i] if selection[i].is_a?(Sketchup::Edge) && ( selection[i].hidden? ||  selection[i].soft?) } if check_hide_edge
				return (selection-sels)
			end
			def center_face(face)
				vertices= face.outer_loop.vertices
				numver=vertices.length
				cp=Geom::Point3d.new
				vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ numver
				cp.y=cp.y/ numver
				cp.z=cp.z/ numver
				return cp
			end
			def points_on_plane(points,plane)
				p1=points[0].clone;p2=points[1].clone
				t_plane=Geom::Transformation.new(plane[0],plane[1])
				p1.transform! t_plane.inverse
				p2.transform! t_plane.inverse
				return (((p1.z>0) && (p2.z>=0)) || ((p1.z>=0) && (p2.z>0)))
			end
			def middle_point(points)
				return Geom::Point3d.linear_combination(0.5,points[0],0.5,points[1])
			end
			def intersect_line_planes_ins(line,planes_ins)
				intersect=[]
				planes_in=planes_ins[5]
				number=0.000001
				(0..(planes_in.length-1)).each{|i|
					plan= planes_in[i][0]
					plan1=planes_in[i][1]
					plan2=planes_in[i][2]
					p =Geom.intersect_line_plane(line,plan)
					if p && (point_on_plane(p,plan1)>=number) &&  (point_on_plane(p,plan2)>=number)
						intersect<<p
					end
				}
				intersect.uniq!
				intersect.sort!{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
				return intersect
			end
			def point_on_section_planes(point,planes_ins)
				#planes_ins=[@planes,ps_screen,close,in_ps_screen,@ctrl_press,@intersect_planes]
				planes_in=planes_ins[5]
				number=0.000001
				if planes_in.length==1
					return point_on_plane(point,planes_in[0][0])
				else
					points1=points2=points3=[]
					points1= intersect_line_planes_ins([point,X_AXIS],planes_ins)
					points2= intersect_line_planes_ins([point,Y_AXIS],planes_ins)
					points3= intersect_line_planes_ins([point,Geom::Vector3d.new(1,1,0)],planes_ins)
					[points1,points2,points3].each{|points|
					(0..points.length-2).each{|i|
						#if points[i]!= points[i+1]
							if i%2==0
								if Geom.point_in_polygon_2D(point,[points[i], points[i+1]],true)
									dis1=point.distance(points[i])
									dis2=point.distance(points[i+1])
									if dis1>number && dis2>number &&
										point!=points[i] && point!=points[i+1]
										return 1
									elsif dis1<=number || dis2<=number ||
										point==points[i] || point==points[i+1]
										return 0
									end
								end
							else
								if Geom.point_in_polygon_2D(point,[points[i], points[i+1]],true)
									dis1=point.distance(points[i])
									dis2=point.distance(points[i+1])
									if  dis1>number && dis2>number &&
										point!=points[i] && point!=points[i+1]
										return -1
									elsif dis1<=number || dis2<=number ||
										point==points[i] || point==points[i+1]
										return 0
									end
								end
							end
						#end
					}
					}
				end
				return -1
			end
			def points_on_planes(points,planes_ins)
				if planes_ins[0].length==1
					return points_on_plane(points,planes_ins[0][0][0])
				else
					mid=middle_point(points)
					pmid=point_on_section_planes(mid,planes_ins)
					if planes_ins[3]
						return (pmid>0)
					else
						return (pmid<0)
					end
				end
				return false
			end
			def point_about_planes_ins(points,planes_ins)
				#planes_ins=[@planes,ps_screen,close,in_ps_screen,@ctrl_press,@intersect_planes]
				if (planes_ins[0].length==1)
					if points.any?{|p| point_on_plane(p,planes_ins[0][0][0])>0}
						if points.any?{|p| point_on_plane(p,planes_ins[0][0][0])<0}
							return 0
						else
							return 1
						end
					elsif points.any?{|p| point_on_plane(p,planes_ins[0][0][0])==0}
						return 0
					else
						return -1
					end
				else
					view=Sketchup.active_model.active_view
					ps_screen=planes_ins[1]
					points_screen=points.collect{|p| [screen_coords(p,planes_ins[4]).x,screen_coords(p,planes_ins[4]).y,0]}
					if planes_ins[3]
						if points_screen.all?{|p| Geom.point_in_polygon_2D(p,ps_screen,false)}
							return 1
						elsif points_screen.any?{|p| Geom.point_in_polygon_2D(p,ps_screen,true)}
							return 0
						else
							return -1
						end
					else
						if points_screen.all?{|p| Geom.point_in_polygon_2D(p,ps_screen,false)}
							return -1
						elsif points_screen.any?{|p| Geom.point_in_polygon_2D(p,ps_screen,true)}
							return 0
						else
							return 1
						end
					end
				end
				return 0
			end
			def get_bounds(element)
				a=element.transformation.to_a
				b=nil
				if element.is_a?Sketchup::ComponentInstance
					b=element.definition.bounds
				elsif element.is_a?Sketchup::Group
					b=element.local_bounds
				else
					return []
				end
				return (0..7).collect{|i| b.corner(i).clone.transform! element.transformation } if b
				return []
			end
			def element_on_planes(element,planes_ins,t=Geom::Transformation.new)
				#planes_ins=[@planes,ps_screen,true,in_ps_screen,@ctrl_press,planes]
				corner=[]
				if element.is_a?(Sketchup::ConstructionPoint)
					corner<< element.position.transform(t)
				else
					if (element.is_a?Sketchup::ComponentInstance) ||(element.is_a?Sketchup::Group)
						corner=get_bounds(element)
					end
					if !corner || corner.empty?
						bounds=element.bounds
						corner=(0..7).collect{|i| bounds.corner(i).transform(t)}
					end
					corner+=corner.combination(2).collect{|ps| middle_point(ps)}
				end
				corner_screen=corner.collect{|p1| screen_coords(p1,planes_ins[4])}
				box=Geom::BoundingBox.new
				corner_screen.each{|p| box.add p}
				ps_screen=(0..7).collect{|i| box.corner(i)}
				if planes_ins[1].any?{|p1| Geom.point_in_polygon_2D(p1,ps_screen,true)}
					return 0
				else
					return point_about_planes_ins(corner,planes_ins)
				end
			end
			def point_on_plane(point,plane)
				p1=point.clone
				t_plane=Geom::Transformation.new(plane[0],plane[1])
				p1.transform! t_plane.inverse
				return 0 if p1.z.abs<0.000001
				return p1.z
			end
			def normal_face(face,t=Sketchup.active_model.edit_transform)
				vx=nil;vy=nil;line=nil
				ver=face.outer_loop.vertices.collect{|v| v.position.transform t}
				(0..ver.length-2).each{|i|
					vx=ver[i].vector_to ver[i+1]
					line=ver[i],ver[i+1]
					if vx.length!=0 && line
						(0..ver.length-1).each{|i|
							v2=ver[i].project_to_line line
							vy=v2.vector_to ver[i]
							break if vy.length!=0
						}
						normal=vx.cross vy if vx && vy
						if normal.length!=0
							facenormal=face.normal.transform t
							normal.reverse! if (normal.angle_between facenormal) >= Math::PI*0.5
							return normal
						end
					end
				}
				return face.normal
			end
		end
        def self.save_state(list,pop=true,state=Sketchup.active_model.selection.to_a)
            max=20
            if @last_setting['max_states']
                max = @last_setting['max_states'].to_i
                max= max.between?(1,1000) ? max : 20
            end
            state.select!{|e| e && e.valid?}
            state.collect!{|e| e.persistent_id}
            return list if state.empty?
            if pop
                if list.empty? || ((state-list[-1]).length != 0) || ((list[-1]-state).length != 0)
                    list<<state
                    if list.length> max
                        list.shift
                    end
                 end
            else
                if list.empty? || ((state-list[0]).length != 0) || ((list[0]-state).length != 0)
                    list.unshift state
                    if list.length> max
                        list.pop
                    end
                end
            end
            return list
		end
		def self.selection_previous
			model = Sketchup.active_model
            # if model.selection.to_a.length>0
            #     @select_states[@model_guid][1]=save_state(@select_states[@model_guid][1],false)
            # end
			return if !@select_states[@model_guid][0] || @select_states[@model_guid][0].empty?
            select_states=@select_states[@model_guid][0].pop
            select_states=model.find_entity_by_persistent_id select_states
            select_states.select!{|e| e && e.valid?}
            return if select_states.empty?
            @select_states[@model_guid][1]=save_state(@select_states[@model_guid][1],false,select_states.clone)
            self.remove_selection_observer
            model.selection.clear
            model.selection.add select_states.select{|e| e && e.valid? && e.is_a?(Sketchup::Drawingelement)}
            self.add_selection_observer
		end
		def self.selection_next
			model = Sketchup.active_model
            # if model.selection.to_a.length>0
            #     @select_states[@model_guid][0]=save_state(@select_states[@model_guid][0])
            # end
			return if !@select_states[@model_guid][1] || @select_states[@model_guid][1].empty?
            select_states=@select_states[@model_guid][1].shift
            select_states=model.find_entity_by_persistent_id select_states
            select_states.select!{|e| e && e.valid?}
            return if select_states.empty?
            @select_states[@model_guid][0]=save_state(@select_states[@model_guid][0],true,select_states.clone)
            self.remove_selection_observer
            model.selection.clear
            model.selection.add select_states.select{|e| e && e.valid? && e.is_a?(Sketchup::Drawingelement)}
            self.add_selection_observer
		end
        def self.get_setting()
            if !@last_setting
                if s=S4U::get_file(Dir_s4u_name,NAME)
                    @last_setting = JSON.parse s[0]
                else
                    @last_setting={}
                    @last_setting['max_states']=20
                end
            end
            rescue=>error
            p error,error.backtrace.join("\n")
        end
        def self.save_setting
            prompts =[Strings["Max Previous Next States"]]
            defaults=[20]
            input = UI.inputbox(prompts,defaults,Strings["Setting"])
            if input
                last_setting=input[0].to_i
                if last_setting>0
                    @last_setting['max_states']=last_setting
                    S4U::set_file(Dir_s4u_name,NAME, [@last_setting.to_json] )
                end
            end
            rescue=>error
            p error,error.backtrace.join("\n")
        end
        class S4u_selection_observer < Sketchup::SelectionObserver
            def onSelectionBulkChange(selection)
                change_selection(selection)
            end
            private
            def change_selection(selection)
                select_states = S4U::S4u_crop_selection.instance_variable_get(:@select_states)
                model_guid = S4U::S4u_crop_selection.instance_variable_get(:@model_guid)
                if select_states && model_guid && select_states[model_guid] &&
                    select_states[model_guid][0] && selection.to_a.length>0
                    select_states[model_guid][0] = S4U::S4u_crop_selection.save_state(select_states[model_guid][0],true,selection.to_a)
                    S4U::S4u_crop_selection.instance_variable_set :@select_states ,select_states
                end
            end
        end
        class ModelObserver < Sketchup::ModelObserver
            def onSaveModel(model)
                model_guid= S4U::S4u_crop_selection.instance_variable_get :@model_guid
                if model_guid
                    select_states = S4U::S4u_crop_selection.instance_variable_get(:@select_states)
                    if select_states && select_states[model_guid] && model_guid!=model.guid
                        select_states[model.guid]=select_states[model_guid]
						select_states.delete(model_guid)
                        S4U::S4u_crop_selection.instance_variable_set :@select_states ,select_states
                        S4U::S4u_crop_selection.instance_variable_set :@model_guid ,model.guid
                    end
                end
            end
        end
        class AppObserver < Sketchup::AppObserver
            def onNewModel(model)
                observer_model(model)
            end
            def onOpenModel(model)
                observer_model(model)
            end
            def expectsStartupModelNotifications
                return true
            end
            private
            def observer_model(model)
                Sketchup.active_model.add_observer(ModelObserver.new)
                S4U::S4u_crop_selection.get_setting
                S4U::S4u_crop_selection.add_selection_observer
            end
        end
        def self.add_selection_observer()
            @model_guid=Sketchup.active_model.guid if !@model_guid || @model_guid!=Sketchup.active_model.guid
            @select_states={} if !@select_states
            @select_states[@model_guid]=[[],[],S4u_selection_observer.new] if !@select_states[@model_guid]
            Sketchup.active_model.selection.add_observer(@select_states[@model_guid][2]) if @select_states[@model_guid][2]
        end
        def self.remove_selection_observer()
            Sketchup.active_model.selection.remove_observer(@select_states[@model_guid][2]) if @select_states[@model_guid][2]
        end
		def self.main(mode)
            if mode==0
                self.selection_previous
            elsif mode==1
                self.selection_next
            elsif mode==2
                Sketchup.active_model.select_tool Select.new
            else
                self.save_setting
            end
		end
        unless file_loaded?(__FILE__)
            Sketchup.add_observer(AppObserver.new)
        end
	end
end